<template>
  <div class="main-content stats-page">
    <h1 class="stats-page-header">
      <b>Анализ</b>
      <br />всеросcийской <br />переписи <br />населения
    </h1>

    <div class="stats-page-content">
      <p>
        С другой стороны начало повседневной работы по формированию позиции
        обеспечивает широкому кругу (специалистов) участие в формировании
        существенных финансовых и административных условий. Идейные соображения
        высшего порядка, а также укрепление и развитие структуры способствует
        подготовки и реализации новых предложений.
      </p>
      <p>
        Идейные соображения высшего порядка, а также новая модель
        организационной деятельности позволяет оценить значение системы обучения
        кадров, соответствует насущным потребностям.
      </p>
      <p>
        Значимость этих проблем настолько очевидна, что постоянный
        количественный рост и сфера нашей активности в значительной степени
        обуславливает создание системы обучения кадров, соответствует насущным
        потребностям. Не следует, однако забывать, что рамки и место обучения
        кадров требуют от нас анализа систем массового участия.
      </p>

      <h2>Статистика</h2>
      <div class="stats-page-diagram-block">
        <div class="first-column">
          <div class="diagram-card">
            <div class="diagram-card-heading">
              <div>
                Статистика по населению
                <br />динамика роста
              </div>
              <div>Показать: за последние 100 лет</div>
            </div>
            <div class="diagram-card-content">
              <line-chart
                :series="series"
                :categorys="categorys"
                :mouse-move-event="mouseMoveEvent"
              />
            </div>
          </div>
        </div>
        <div>
          <div class="diagram-card">
            <div class="diagram-card-heading">
              Соотношение жителей городской и сельской местности
            </div>
            <div class="diagram-card-content">
              <pie-chart :series="circleSeries" />
              <div class="diagram-card-piechart-legend">
                <div
                  class="piechart-legend-item"
                  :key="`row-${index}`"
                  v-for="(item, index) in sortedCircleSeries"
                >
                  <i :style="{ borderColor: item.color }"></i>
                  {{ item.name }}
                </div>
              </div>
            </div>
          </div>
          <div class="diagram-card blue mt-18">
            <div class="diagram-card-content">
              <div class="card-total-block">
                <div>Итого:</div>
                <div>
                  <div class="periud">
                    c {{ categorys[0] }} - {{ categorys.slice(-1)[0] }}
                  </div>
                  <div class="total">+ {{ totalProc }}%</div>
                </div>
              </div>
            </div>
          </div>
        </div>
      </div>

      <p>
        С другой стороны начало повседневной работы по формированию позиции
        обеспечивает широкому кругу (специалистов) участие в формировании
        существенных финансовых и административных условий. Идейные соображения
        высшего порядка, а также укрепление и развитие структуры способствует
        подготовки и реализации новых предложений.
      </p>
      <p>
        Идейные соображения высшего порядка, а также новая модель
        организационной деятельности позволяет оценить значение системы обучения
        кадров, соответствует насущным потребностям.
      </p>
      <p>
        Значимость этих проблем настолько очевидна, что постоянный
        количественный рост и сфера нашей активности в значительной степени
        обуславливает создание системы обучения кадров, соответствует насущным
        потребностям. Не следует, однако забывать, что рамки и место обучения
        кадров требуют от нас анализа систем массового участия.
      </p>
    </div>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from "vue-property-decorator";
import LineChart from "@/components/charts/LineChart.vue";
import PieChart from "@/components/charts/PieChart.vue";
import rest from "@/rest";
import _ from "lodash";

@Component({
  components: { LineChart, PieChart }
})
export default class StatsPeoplePage extends Vue {
  populationData: any = [];
  categorys: any = [];
  selectData: number = 0;
  colors = ["#F7004A", "#109CF1"];

  mouseMoveEvent(option: any) {
    this.selectData = option.dataPointIndex > -1 ? option.dataPointIndex : 0;
  }

  get totalProc() {
    let first = this.series[0].data[0];
    let last = this.series[0].data.slice(-1)[0];
    return (((last - first) / first) * 100).toFixed(0);
  }

  get sortedCircleSeries() {
    return _.sortBy(this.circleSeries, "value").reverse();
  }

  get circleSeries() {
    let city = this.series[1].data[this.selectData];
    let rural = this.series[2].data[this.selectData];
    return [
      {
        value: city,
        name: "Городское население",
        color: city > rural ? this.colors[0] : this.colors[1]
      },
      {
        value: rural,
        name: "Сельское население",
        color: city < rural ? this.colors[0] : this.colors[1]
      }
    ];
  }

  get series() {
    let city_population = [];
    let population = [];
    let rural_population = [];
    let years = [];

    for (let item of this.populationData) {
      city_population.push(item.city_population);
      population.push(item.population);
      rural_population.push(item.rural_population);
      years.push(item.year);
    }
    this.categorys = years;

    return [
      {
        name: "Население",
        data: population
      },
      {
        name: "Городское население",
        data: city_population
      },
      {
        name: "Сельское население",
        data: rural_population
      }
    ];
  }

  mounted() {
    rest.population
      .get()
      .then((result: any) => {
        this.populationData = result.data;
      })
      .catch((err: any) => {});
  }
}
</script>
